using System;

namespace Adoor.Expression.AST
{
	/// <summary>
	/// Summary description for HavingExpression.
	/// </summary>
	public class HavingExpression
	{
		public ExpressionNode Expr;
		public HavingExpression(ExpressionNode expr)
		{
			this.Expr = expr;
		}

		public static HavingExpression ParseHavingExpression(Scanner scanner)
		{
			ExpressionParser ep = new ExpressionParser();
			scanner.Scan();
			ExpressionNode expr = ep.ParseSearchCondition(scanner);
			return new HavingExpression(expr);
		}		
	}
}
