using System;
using System.Collections.Generic;
using System.Text;

using Adoor.Mapping.Attributes;

namespace Adoor.Mapping
{
    public interface IVisitor
    {
        void CloseConfig();
        void Visit(Type type);
        void Visit(EntityAttribute attribute);
        void Visit(KeyAttribute attribute,System.Reflection.MemberInfo member);
        void Visit(PropertyAttribute attribute,System.Reflection.MemberInfo member);
        void Visit(OneToManyAttribute attribut,System.Reflection.MemberInfo member);

  
    }
}
