namespace Adoor.Metadata 
{
	using System;
	using System.Collections;
	using System.Windows.Forms;
	using System.Xml;
	using System.Xml.Xsl;
	using System.Text;
	using System.IO;
	using System.Security;
	using System.Security.Policy;
	using System.Security.Permissions;
	using System.Text.RegularExpressions;

	public class MetadataForm : Form, IXmlWriterProvider
	{
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem It_OpenXml;
		private System.Windows.Forms.OpenFileDialog openFileDialogXml;
		private System.Windows.Forms.OpenFileDialog openFileDialogXsl;
		private System.Windows.Forms.MenuItem It_Transform;
		private System.Windows.Forms.TabPage tabPageXml;
		private System.Windows.Forms.RichTextBox richTextBoxXml;
		private System.Windows.Forms.TabPage tabPageXsl;
		private System.Windows.Forms.RichTextBox richTextBoxXsl;
		private System.Windows.Forms.TabControl tabControl1;
		private System.Windows.Forms.MenuItem It_Save;
		public System.Windows.Forms.SaveFileDialog saveFileDialog1;
		private System.Windows.Forms.MenuItem menuItem3;

		[STAThread]

	#region "Vs methods"
		private void InitializeComponent()
		{
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.It_OpenXml = new System.Windows.Forms.MenuItem();
			this.menuItem3 = new System.Windows.Forms.MenuItem();
			this.It_Transform = new System.Windows.Forms.MenuItem();
			this.It_Save = new System.Windows.Forms.MenuItem();
			this.openFileDialogXml = new System.Windows.Forms.OpenFileDialog();
			this.openFileDialogXsl = new System.Windows.Forms.OpenFileDialog();
			this.tabPageXml = new System.Windows.Forms.TabPage();
			this.richTextBoxXml = new System.Windows.Forms.RichTextBox();
			this.tabPageXsl = new System.Windows.Forms.TabPage();
			this.richTextBoxXsl = new System.Windows.Forms.RichTextBox();
			this.tabControl1 = new System.Windows.Forms.TabControl();
			this.saveFileDialog1 = new System.Windows.Forms.SaveFileDialog();
			this.tabPageXml.SuspendLayout();
			this.tabPageXsl.SuspendLayout();
			this.tabControl1.SuspendLayout();
			this.SuspendLayout();
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem1});
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 0;
			this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.It_OpenXml,
																					  this.menuItem3,
																					  this.It_Transform,
																					  this.It_Save});
			this.menuItem1.Text = "File";
			// 
			// It_OpenXml
			// 
			this.It_OpenXml.Index = 0;
			this.It_OpenXml.Text = "Open XML...";
			this.It_OpenXml.Click += new System.EventHandler(this.It_OpenXml_Click);
			// 
			// menuItem3
			// 
			this.menuItem3.Index = 1;
			this.menuItem3.Text = "Open XSL...";
			this.menuItem3.Click += new System.EventHandler(this.It_OpenXslt_Click);
			// 
			// It_Transform
			// 
			this.It_Transform.Index = 2;
			this.It_Transform.Text = "Transform";
			this.It_Transform.Click += new System.EventHandler(this.It_Transform_Click);
			// 
			// It_Save
			// 
			this.It_Save.Index = 3;
			this.It_Save.Text = "Save Result";
			this.It_Save.Click += new System.EventHandler(this.It_Save_Click);
			// 
			// openFileDialogXml
			// 
			this.openFileDialogXml.Filter = "XML files (*.xml)|*.xml|XMI files (*.xmi)|*.xmi";
			this.openFileDialogXml.FileOk += new System.ComponentModel.CancelEventHandler(this.openFileDialogXml_FileOk);
			// 
			// openFileDialogXsl
			// 
			this.openFileDialogXsl.Filter = "XSLT files (*.xslt)|*.xslt";
			this.openFileDialogXsl.FileOk += new System.ComponentModel.CancelEventHandler(this.openFileDialogXsl_FileOk);
			// 
			// tabPageXml
			// 
			this.tabPageXml.AutoScroll = true;
			this.tabPageXml.Controls.Add(this.richTextBoxXml);
			this.tabPageXml.Location = new System.Drawing.Point(4, 22);
			this.tabPageXml.Name = "tabPageXml";
			this.tabPageXml.Size = new System.Drawing.Size(544, 359);
			this.tabPageXml.TabIndex = 0;
			this.tabPageXml.Text = "XML";
			// 
			// richTextBoxXml
			// 
			this.richTextBoxXml.Dock = System.Windows.Forms.DockStyle.Fill;
			this.richTextBoxXml.Location = new System.Drawing.Point(0, 0);
			this.richTextBoxXml.Name = "richTextBoxXml";
			this.richTextBoxXml.Size = new System.Drawing.Size(544, 359);
			this.richTextBoxXml.TabIndex = 0;
			this.richTextBoxXml.Text = "";
			// 
			// tabPageXsl
			// 
			this.tabPageXsl.Controls.Add(this.richTextBoxXsl);
			this.tabPageXsl.Location = new System.Drawing.Point(4, 22);
			this.tabPageXsl.Name = "tabPageXsl";
			this.tabPageXsl.Size = new System.Drawing.Size(544, 359);
			this.tabPageXsl.TabIndex = 1;
			this.tabPageXsl.Text = "XSL";
			// 
			// richTextBoxXsl
			// 
			this.richTextBoxXsl.Dock = System.Windows.Forms.DockStyle.Fill;
			this.richTextBoxXsl.Location = new System.Drawing.Point(0, 0);
			this.richTextBoxXsl.Name = "richTextBoxXsl";
			this.richTextBoxXsl.Size = new System.Drawing.Size(544, 359);
			this.richTextBoxXsl.TabIndex = 0;
			this.richTextBoxXsl.Text = "";
			// 
			// tabControl1
			// 
			this.tabControl1.Controls.Add(this.tabPageXml);
			this.tabControl1.Controls.Add(this.tabPageXsl);
			this.tabControl1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.tabControl1.ItemSize = new System.Drawing.Size(42, 18);
			this.tabControl1.Location = new System.Drawing.Point(0, 0);
			this.tabControl1.Name = "tabControl1";
			this.tabControl1.SelectedIndex = 0;
			this.tabControl1.Size = new System.Drawing.Size(552, 385);
			this.tabControl1.TabIndex = 0;
			// 
			// MetadataForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(552, 385);
			this.Controls.Add(this.tabControl1);
			this.Menu = this.mainMenu1;
			this.Name = "MetadataForm";
			this.tabPageXml.ResumeLayout(false);
			this.tabPageXsl.ResumeLayout(false);
			this.tabControl1.ResumeLayout(false);
			this.ResumeLayout(false);

		}

		public static int Main(string[] args) 
		{
			Application.Run(new MetadataForm());
			return 0;
		}

		public MetadataForm() 
		{
			InitializeComponent();
		}
		#endregion

	#region "Private methods"
		private void It_Save_Click(object sender, System.EventArgs e)
		{
			SaveData(ExtractFilePath(saveFileDialog1.FileName));
		}

		private static string ExtractFilePath(string fileName)
		{
			int pos = fileName.LastIndexOf("\\");
			if (pos == -1)
				return "";
			return fileName.Substring(0, pos);
		}

		private static void ForceDirectory(string fileName)
		{
			if (fileName == "")
				return;
			System.IO.Directory.CreateDirectory(fileName);
		}
	#endregion
		
	# region "Public methods"

		public void OpenXmlFile(string aXmlFile)
		{
			richTextBoxXml.LoadFile(aXmlFile, RichTextBoxStreamType.PlainText);
		}
		public void OpenXsltFile(string aXmlFile)
		{
			richTextBoxXsl.LoadFile(aXmlFile, RichTextBoxStreamType.PlainText);
		}
		public void MakeTransformation()
		{
			try
			{
				this.Cursor = System.Windows.Forms.Cursors.WaitCursor;
				while (tabControl1.TabPages.Count > 2)
					tabControl1.TabPages.RemoveAt(tabControl1.TabPages.Count - 1);

				XmlDocument xmlDocument = new XmlDocument();
				xmlDocument.LoadXml(richTextBoxXml.Text);
				XmlDocument xslDocument = new XmlDocument();
				xslDocument.LoadXml(richTextBoxXsl.Text);

                XslCompiledTransform xslTransform = new XslCompiledTransform(true);
				//xslTransform.Load(xslDocument/*, null, null*/);
				xslTransform.Load(xslDocument);
				StringBuilder sb = new StringBuilder();

				XsltArgumentList args = new XsltArgumentList();
				foreach(XmlNode pi in xslDocument.SelectNodes("descendant::processing-instruction()[local-name()='arg']"))
				{
					int pos = pi.Value.IndexOf("=");
					if (pos == -1)
						throw new Exception("processing instruction format error: expecting \"<?arg namespace=type ?>\"");
					string ns = pi.Value.Substring(0, pos).Trim();
					string typeName = pi.Value.Substring(pos + 1).Trim();
					Type type = Type.GetType(typeName);
					if (type == null)
						throw new Exception("type " + typeName + " not found");
					object arg = type.GetConstructor(new Type[]{}).Invoke(null);
					args.AddExtensionObject(ns, arg);
				}

				XmlNamespaceManager nsmgr = new XmlNamespaceManager(new NameTable());
				nsmgr.AddNamespace("xsl", "http://www.w3.org/1999/XSL/Transform");
				nsmgr.AddNamespace("io", "urn:xmd-io");
				if (xslDocument.SelectSingleNode("/xsl:stylesheet/xsl:output[@method='text']", nsmgr) != null)
				{
					xslTransform.Transform(xmlDocument, args, new StringWriter(sb));
					string result = sb.ToString();
					RichTextBox richTextBoxResult = null;
					while (result != "")
					{
						int i = result.IndexOf("\n");
						string line;
						if (i == -1)
						{
							line = result;
							result = "";
						}
						else
						{
							line = result.Substring(0, i + 1);
							result = result.Substring(i + 1);
						}
						if (line.StartsWith("---- File: "))
						{
							string fileName = line.Substring("---- File: ".Length);
							bool merge = false;

							if(fileName.StartsWith("merge "))
							{
								fileName = fileName.Substring("merge ".Length);
								merge = true;
							}

							if (fileName.EndsWith("\n"))
								fileName = fileName.Substring(0, fileName.Length - 1);
							richTextBoxResult = CreateTabPage(fileName, merge);
							continue;
						}

						if (richTextBoxResult == null)
							richTextBoxResult = CreateTabPage("Result", false);

						richTextBoxResult.Text += line;
					}
				}
				else 
				{

#if TOTO
					XmlTextWriter xmlTextWriter = new XmlTextWriter(new StringWriter(sb));
					xslTransform.Transform(xmlDocument, args, xmlTextWriter/*, null*/);

					XmlDocument result = new XmlDocument();
					result.LoadXml(sb.ToString());
					foreach(XmlNode file in result.SelectNodes("/Root/io:CreateFile", nsmgr))
					{
						RichTextBox richTextBoxChild = CreateTabPage(file.SelectSingleNode("@name").Value);
						foreach(XmlNode child in file.ChildNodes)
						{
							sb.Length = 0;
							xmlTextWriter.Formatting = Formatting.Indented;
							xmlTextWriter.Indentation = 8;
							child.WriteTo(xmlTextWriter);
							richTextBoxChild.Text += sb.ToString();
						}
						file.ParentNode.RemoveChild(file);
					}
					RichTextBox richTextBoxResult = CreateTabPage("Result");
					sb.Length = 0;
					xmlTextWriter.Formatting = Formatting.Indented;
					xmlTextWriter.Indentation = 8;
					result.Save(xmlTextWriter);
					richTextBoxResult.Text += sb.ToString();
#endif
					XmlWriter xmlWriter = new XmlMultiFileWriter(this);
					//xslTransform.Transform(xmlDocument, args, xmlWriter/*, null*/);
					xslTransform.Transform(xmlDocument, args, xmlWriter);
					tabControl1.SelectedIndex = 2;
				}
			}
			catch (Exception ex)
			{
				MessageBox.Show(ex.StackTrace);
				while (ex != null) 
				{
					MessageBox.Show(ex.Message);
					ex = ex.InnerException;
				}
			}
			finally
			{
				this.Cursor = System.Windows.Forms.Cursors.Default;
			}
		}

		public void SaveData(string aDirName)
		{
			ArrayList notGeneratedFiles = new ArrayList(this.tabControl1.TabPages.Count - 2);
			for(int i = 2; i < this.tabControl1.TabPages.Count; i++)
			{
				TabPage tabPage = tabControl1.TabPages[i];
				bool merge = (bool) tabPage.Tag;
				string fileName = tabPage.Text;
				fileName = fileName.Replace(".DataAccess.DataAccess",".DataAccess");
				if (fileName == "Result")
				{
					if (aDirName.Trim() == "")
					{
						if (saveFileDialog1.FileName.Trim() != "")
							if (saveFileDialog1.ShowDialog() != DialogResult.OK)
								continue;
						fileName = saveFileDialog1.FileName;
					}
					else
						fileName = aDirName;
				}

				else if (aDirName.Trim() != "")
					fileName = aDirName + "\\" + fileName;
				RichTextBox richTextBox = (RichTextBox)tabPage.Controls[0];
				ForceDirectory(ExtractFilePath(fileName));
				try
				{
					if(merge && System.IO.File.Exists(fileName))
						MergeData(richTextBox.Text, fileName);
					else
				richTextBox.SaveFile(fileName,
					RichTextBoxStreamType.PlainText);
			}
				catch(System.UnauthorizedAccessException)
				{
					notGeneratedFiles.Add(fileName);
				}
			}

			if(notGeneratedFiles.Count != 0)
			{
				System.Text.StringBuilder sb = new StringBuilder();
				foreach(string s in notGeneratedFiles)
					sb.AppendFormat("{0}\n", s);

				MessageBox.Show(null, 
					string.Concat("Generation failed for the folowing files : \n", sb.ToString()),
					"Failed", MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
		}

		public void MergeData(string text, string fileName)
		{
			FileStream fs = File.OpenRead(fileName);
			StreamReader sr = new StreamReader(fs);
			string existingFile = sr.ReadToEnd();
			string newFile = text;
			
			Regex regexExisting = new Regex(
				@"(?<region>\#region\s(?<def>user\scode\s[^\n]*))",
				RegexOptions.IgnoreCase | RegexOptions.Multiline 
				| RegexOptions.IgnorePatternWhitespace  | RegexOptions.ExplicitCapture 
				| RegexOptions.Compiled);	

			MatchCollection matchFcts = regexExisting.Matches(existingFile);
			foreach(Match match in matchFcts)
			{
				string def = match.Groups["def"].Value;
				string endRegion = string.Concat("#endregion ", def).Trim();
				def = Regex.Escape(def.Trim());
				int endExisting = existingFile.IndexOf(endRegion, match.Index);
				if(endExisting >= 0)
				{				
					Regex regexNewFile = new Regex(
						string.Concat(@"(?<region>\#region\s", def ,")",
						@"(?<code>[^#]*)(?<endregion-region>\#endregion\s", def, @"(?<endspace>\s))"),
						RegexOptions.IgnoreCase | RegexOptions.Multiline 
						| RegexOptions.IgnorePatternWhitespace  | RegexOptions.ExplicitCapture 
						| RegexOptions.Compiled);
					newFile = regexNewFile.Replace(newFile, string.Concat(existingFile.Substring(match.Index, endExisting + endRegion.Length - match.Index), "${endspace}"));
				}
			}
			sr.Close();
			fs.Close();
			StreamWriter sw = File.CreateText(fileName);
			sw.Write(newFile);
			sw.Close();
		}

	#endregion

	#region "Interactivity"
		private void It_OpenXml_Click(object sender, System.EventArgs e)
		{
			openFileDialogXml.ShowDialog();
			tabControl1.SelectedTab = tabPageXml;
		}

		private void It_OpenXslt_Click(object sender, System.EventArgs e)
		{
			openFileDialogXsl.ShowDialog();
			tabControl1.SelectedTab = tabPageXsl;
		}

		private void openFileDialogXml_FileOk(object sender, System.ComponentModel.CancelEventArgs e)
		{
			OpenXmlFile(openFileDialogXml.FileName);
		}

		private void openFileDialogXsl_FileOk(object sender, System.ComponentModel.CancelEventArgs e)
		{
			OpenXsltFile(openFileDialogXsl.FileName);
		}

		private void It_Transform_Click(object sender, System.EventArgs e)
		{
			MakeTransformation();
		}

		XmlWriter IXmlWriterProvider.GetWriter(string name)
		{
			if (name == null)
				name = "Result";
			return new XmlRichTextBoxWriter(CreateTabPage(name, false));
		}

		public RichTextBox CreateTabPage(string Caption, bool merge)
		{
			TabPage tabPageResult = new System.Windows.Forms.TabPage();
			tabPageResult.Tag = merge;
			RichTextBox richTextBoxResult = new System.Windows.Forms.RichTextBox();
			// 
			// tabPageResult
			// 
			tabPageResult.AutoScroll = true;
			tabPageResult.Controls.Add(richTextBoxResult);
			tabPageResult.Location = new System.Drawing.Point(4, 22);
			tabPageResult.Name = "tabPageResult";
			tabPageResult.Size = new System.Drawing.Size(544, 359);
			tabPageResult.TabIndex = 0;
			tabPageResult.Text = Caption;
			// 
			// richTextBoxResult
			// 
			richTextBoxResult.Dock = System.Windows.Forms.DockStyle.Fill;
			richTextBoxResult.Location = new System.Drawing.Point(0, 0);
			richTextBoxResult.Name = "richTextBoxResult";
			richTextBoxResult.Size = new System.Drawing.Size(544, 359);
			richTextBoxResult.TabIndex = 0;
			richTextBoxResult.Text = "";
			// 
			// tabControl1
			// 
			this.tabControl1.Controls.Add(tabPageResult);

			return richTextBoxResult;
		}

		#endregion

		
	}
#region "XmlTools"
	

	

	

	

	
#endregion

}
