using System;

namespace Adoor.Metadata
{
	public interface IProgress
	{
		event ProgressEventHandler Progress;		
	}

	public delegate void ProgressEventHandler (object sender, ProgressEventArgs e);
	public class ProgressEventArgs :EventArgs
	{
		public ProgressEventArgs(int current, int total)
		{
			this._current = current;
			this._total = total;
		}
		
		private int _current;
		
		private int _total;
		
		public int Current
		{
			get{ return _current;}
		}
		
		public int Total
		{
			get{ return _total; }
		}
		
	}
}
