
using System;
using System.CodeDom;
using System.CodeDom.Compiler;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Reflection;
using System.Security.Permissions;
using System.Xml;
using Adoor.Object.Domain;
using Adoor.Object.Entity;
using Microsoft.CSharp;
using Microsoft.VisualBasic;

namespace Adoor.Object.Domain.DomainBuild.CodeDom
{
    internal class XmlInfoReader
    {
        [ReflectionPermission(SecurityAction.Demand)]
        protected Type getEntityType(XmlNode metadata, XmlNamespaceManager nsmgr, Assembly assembly)
        {
            XmlNode typeNode = metadata.SelectSingleNode("typing:entity/@type", nsmgr);
            if (typeNode == null)
                throw new Exception("type not found for node " + metadata.Name);
            string type = typeNode.Value.Split(',')[0];
            return assembly.GetType(type, true);
        }

    }
}
