using System;

namespace Adoor.Metadata
{
	public interface IMessageProvider
	{
		event LogMessageEventHandler LogMessage;
		
	}

	public delegate void LogMessageEventHandler (object sender, LogMessageEventArgs e);
		
	public class LogMessageEventArgs :EventArgs
	{
		public LogMessageEventArgs(string message, int level)
		{
			this._message = message;
			this._level = level;
		}
		
		private string _message;
		
		private int _level;
		
		public string Message
		{
			get{ return _message;}
		}
		
		public int Level
		{
			get{ return _level; }
		}
		
	}
}
