using System;
using System.Data;
using System.Text;
using System.Collections;

namespace Adoor.Domain.Tiers
{
	
	
	public abstract class Lieu	
	{

		
	
		public virtual String CodePostal
		{
			get
			{
				return this.m_codePostal;
			}
			set
			{ 
				this.m_codePostal = value;
			}
		}


		public virtual String Ville
		{
			get
			{
				return this.m_ville;
			}
			set
			{ 
				this.m_ville = value;
			}
		}

		public virtual String Pays
		{
			get
			{
				return this.m_pays;
			}
			set
			{ 
				this.m_pays = value;
			}
		}					   

		public virtual String CodeInsee
		{
			get
			{
				return this.m_codeInsee;
			}
			set
			{ 
				this.m_codeInsee = value;
			}
		}				

		
		/// <summary>
		/// Called when user is creating a new entity.
		/// </summary>
		protected virtual void OnCreate(object[] args)
		{
			CodeInsee  = "";		
			CodePostal = "";		
			Ville = "";		
			Pays = "";		
		}
		
		/// <summary>
		/// Called when user is retreiving an entity from storage
		/// </summary>
		protected virtual void OnMaterialize()
		{

		}
		
		
		
		protected abstract System.String m_codePostal { get; set; }
		
		protected abstract System.String m_ville { get; set;}
		
		protected abstract System.String m_pays { get; set;}

		protected abstract System.String m_codeInsee { get; set;}
		
		
	}
}
