using System;

namespace Adoor.Domain.Tiers
{
	/// <summary>
	/// Summary description for Tuteur.
	/// </summary>
	public abstract class Tuteur
	{
		public virtual String Nom
		{
			get
			{
				return this.m_nom;
			}
			set
			{ 
				this.m_nom = value;
			}
		}

		public virtual String Prenom
		{
			get
			{
				return this.m_prenom;
			}
			set
			{ 
				this.m_prenom = value;
			}
		}					   

		public virtual Adresse Adresse
		{
			get
			{
				return this.m_adresse;
			}
			set
			{ 
				this.m_adresse = value;
			}
		}


        public virtual Coordonnee Coordonnee
        {
            get
            {
                return m_Coordonnee; 
            }
            set
            {
                m_Coordonnee = value; 
            }
        }

		
		/// <summary>
		/// Called when user is creating a new entity.
		/// </summary>
		protected virtual void OnCreate(object[] args)
		{
			Prenom = "";		
			Nom  = "";		
			
		}
		
		/// <summary>
		/// Called when user is retreiving an entity from storage
		/// </summary>
		protected virtual void OnMaterialize()
		{

		}
		
		
		protected abstract System.String m_nom { get; set; }
		
		protected abstract System.String m_prenom { get; set;}
		
		protected abstract Adresse m_adresse { get; set;}

        protected abstract Coordonnee m_Coordonnee { get; set;}
		
	}
}
